import { pluginUtils } from '@verdaccio/core';
import { Config, Logger, PackageAccess, RemoteUser } from '@verdaccio/types';
import { Users, VerdaccioMemoryConfig } from './types';
declare const Plugin: typeof pluginUtils.Plugin;
export default class Memory extends Plugin<VerdaccioMemoryConfig> implements pluginUtils.Auth<VerdaccioMemoryConfig> {
    _logger: Logger;
    _users: Users;
    _config: {};
    _app_config: Config;
    constructor(config: VerdaccioMemoryConfig, appOptions: pluginUtils.PluginOptions);
    authenticate(user: string, password: string, cb: pluginUtils.AuthCallback): void;
    adduser(user: string, password: string, cb: pluginUtils.AuthUserCallback): void;
    changePassword(username: string, password: string, newPassword: string, cb: pluginUtils.AuthChangePasswordCallback): void;
    allow_access(user: RemoteUser, pkg: PackageAccess, cb: pluginUtils.AccessCallback): void;
    allow_publish(user: RemoteUser, pkg: PackageAccess, cb: pluginUtils.AuthAccessCallback): void;
}
export {};
